EgoBooster = LibStub("AceAddon-3.0"):NewAddon("EgoBooster", "AceConsole-3.0", "AceEvent-3.0")
local AceGUI = LibStub and LibStub("AceGUI-3.0", true)
local isMsgDisplayed = false;
local playerInCombat = false
local playersInCombat = {}
local enemiesInCombat = {}
local bossesInCombat = {}
local fightHadBosses = false
local fightHadEnemies = false
local runningCombatCheck = false
local defeatedEnemiesList = {}
local cleaningIsRunning = false
local playersWereInCombat = false
local maxDefeated = 0

local SpellsInfo = {}

SpellsInfo.cc = {
	61721, 
	118, 
	28271, 
	61305, 
	28272,
	9484, 
	61780, 
	3355, 
	20066, 
	6770, 
	5782, 
	51514, 
	2094, 
	19386,
	145067, 
	710, 
	6358, 
	339, 
	115268, 
	102359, 
    122224, 
	115078, 
	122220, 
	2637, 
	217832, 
}

SpellsInfo.cctime = {
	[28271] = 60, 
	[61721] = 60, 
	[61305] = 60, 
	[118] = 60, 
	[9484] = 50, 
	[28272] = 60, 
	[61780] = 60, 
	[6770] = 60,
	[3355] = 60, 
	[2094] = 60, 
	[20066] = 60, 
	[5782] = 20, 
	[51514] = 60, 
	[710] = 30, 
	[19386] = 30, 
	[115268] = 30,
	[145067] = 40, 
	[6358] = 30, 
	[102359] = 30, 
	[339] = 30, 
    [122220] = 50, 
	[115078] = 60, 
    [122224] = 50, 
	[2637] = 40,
	[217832] = 60, 
}

SpellsInfo.ccaura = {
	3600,  
	5484,  
	31589, 
	1160,
	82691,
	5246, 
	8122,
	12323,
	15487,
	5116,
	13810,
    853,
	2094,
	408,
	1833,
	47476,
	77606,
}

SpellsInfo.br = {
  20484, 
  20707, 
  95750, 
  61999, 
  20608, 
}

SpellsInfo.taunt = {
  355, 
  185245, 
  62124,
  6795,  
  56222, 
  116189,
  49576, 
  20736,
  115546, 
  171014, 
  17735, 
  2649, 
}

SpellsInfo.aoet = {
  36213,
  82407, 
}

local soundMap = {}
soundMap["thuglife"] = "Interface\\AddOns\\EgoBooster\\Sounds\\thug.ogg"
soundMap["yahoo"] = "Interface\\AddOns\\EgoBooster\\Sounds\\Yahoo.ogg"
soundMap["saywhat"] = "Interface\\AddOns\\EgoBooster\\Sounds\\saywhat.ogg"
soundMap["noonehas"] = "Interface\\AddOns\\EgoBooster\\Sounds\\noone.ogg"
soundMap["leeroy"] = "Interface\\AddOns\\EgoBooster\\Sounds\\leeroy.ogg"
soundMap["floatlike"] = "Interface\\AddOns\\EgoBooster\\Sounds\\float.ogg"
soundMap["damnson"] = "Interface\\AddOns\\EgoBooster\\Sounds\\damnson.ogg"
soundMap["whoami"] = "Interface\\AddOns\\EgoBooster\\Sounds\\whoami.ogg"

-- for playing as a test in addon menu
local flirtingMap = {}
flirtingMap["Bloodelf Female"] = "9642"
flirtingMap["Bloodelf Male"] = "9659"

flirtingMap["Drenai Female"] = "9684"
flirtingMap["Drenai Male"] = "9709"

flirtingMap["Dwarf Female"] = "6105"
flirtingMap["Dwarf Male"] = "6114"

flirtingMap["Gnome Female"] = "6123"
flirtingMap["Gnome Male"] = "6132"

flirtingMap["Human Female"] = "6142"
flirtingMap["Human Male"] = "6169"

flirtingMap["Nightelf Female"] = "6178"
flirtingMap["Nightelf Male"] = "6187"

flirtingMap["Orc Female"] = "6358"
flirtingMap["Orc Male"] = "6367"

flirtingMap["Tauren Female"] = "6376"
flirtingMap["Tauren Male"] = "6385"

flirtingMap["Troll Female"] = "6394"
flirtingMap["Troll Male"] = "6403"

flirtingMap["Undead Female"] = "6412"
flirtingMap["Undead Male"] = "6421"

flirtingMap["DH Bloodelf Female"] = "55567"
flirtingMap["DH Bloodelf Male"] = "56537"

flirtingMap["DH Nightelf Female"] = "56157"
flirtingMap["DH Nightelf Male"] = "56292"

flirtingMap["Worgen Female"] = "18759"
flirtingMap["Worgen Male"] = "19013"

flirtingMap["Goblin Female"] = "19240"
flirtingMap["Goblin Male"] = "19131"

flirtingMap["Pandaren Female"] = "31728"
flirtingMap["Pandaren Male"] = "31730"

flirtingMap["Void Elf Female"] = "91336"
flirtingMap["Void Elf Male"] = "91350"

flirtingMap["Lightforged Drenai Female"] = "91264"
flirtingMap["Lightforged Drenai Male"] = "91281"

flirtingMap["Nightborn Female"] = "91294"
flirtingMap["Nightborn Male"] = "91309"

flirtingMap["Highmountain Tauren Female"] = "91211"
flirtingMap["Highmountain Tauren Male"] = "91227"

local flirtingSoundsToUse = {}
local flirtsCount = 0

local function getflirtMapNames()
	local nameMap = {}
	for k, v in pairs(flirtingMap) do
		nameMap[v] = k
	end
	return nameMap
end


local defaults = {
    profile = {
        showInChat = true,
        soundKey = "Human Female",
        time_delay = 60,
        isPlaySound = true,
        soloOn = true,
        partyOn = true,
        isMsgEnabled = true,
		alwaysShowKilledEnemies = true,
        maleOn = true,
        femaleOn = true,
        soundChannel = "Dialog",
        msgColor = {R = 1.0, G = 1.0, B = 1.0},
        BloodElf = true,
        demonHunterBlood = true,
        demonHunterNight = true,
        drenai = true,
        dwarf = true,
        gnome = true,
        goblin = true,
        human = true,
        nightElf = true,
        orc = true,
        pandaren = true,
        tauren = true,
        troll = true,
        undead = true,
        worgen = true,
		nightborn = true,	
		hightaurents = true,
		lightdrenai = true,
		voidelf = true,
        sayWhatAgain = true,
        damnSon = true,
        floatLike = true,
        leeroy = true,
        noonehas = true,
        thuglife = true,
        yahoo = true,
		whoami = true,
		enablebb = true,
		cc = true,
		interrupt = true,
		misdirect = true,
		battleres = true,
		taunt = true,
		dispells= true,
    },
}



local options = {
    name = "EgoBooster",
    handler = EgoBooster,
    type = 'group',
		inline = true,
    args = {

            time_delay = {
      				type = "range",
      				name = "Delay between messages",
      				desc = "Delay in seconds between messages",
      				min = 10, max = 600, step = 10,
      				order = 2,
					get = "getTimeDelay",
					set = "setTimeDelay",
      			},
      			showOptions = {
      				name = "Show Message in Chat",
      				type = "group",
      				inline = true,
      				order = 2,
      				args = {				
						isMsgEnabled = {
                            type = "toggle",
                            name = "Enable Messages",
                            desc = "Toggles the display of the messages.",
                            get = "getisMsgEnabled",
                            set = "setisMsgEnabled",
                            order = 4,
                        },                      
                        msgColor = {
                              type = "color",
                              name = "Message Color",
                              desc = "Pick Message Color",
                              get = "getMsgColor",
                              set = "setMsgColor",
							  disabled = function() return not EgoBooster.db.profile.isMsgEnabled end,
                              order = 5,
                        }, 
						alwaysShowKilledEnemies = {
                              type = "toggle",
                              name = "Show Killed Enemies",
                              desc = "Will always show amount of enemies Killed after combat.",
                              get = function(info) return EgoBooster.db.profile.alwaysShowKilledEnemies end,
                              set = function(info, value)
									EgoBooster.db.profile.alwaysShowKilledEnemies = value                     
                               end,
							  disabled = function() return not EgoBooster.db.profile.isMsgEnabled end,
                              order = 6,
                        },     
					},
      			},
            soundChannel = {
      					name = "Sound Channel",
      					desc = "Which Sound Channel to use.",
      					type = "select",
      					order = 4,
      					values = {Dialog = "Dialog", Master = "Master", SFX = "SFX", Music = "Music", Ambience = "Ambience" },
                --dialogControl = "LSM30_Sound",
                get = "getSoundChannel",
                set = "setSoundChannel",
      				},
      			soundKey = {
      					name = "Sound Previews",
      					desc = "Test different examples.",
      					type = "select",
      					order = 4,
      					values = function() return getflirtMapNames() end,
                --dialogControl = "LSM30_Sound",
                set = "setSoundKey",
                get = "getSoundKey",
      				},
            isPlaySound = {
                  type = "toggle",
                  name = "Play Sounds",
                  desc = "Toggles the play of sounds.",
                  order = 5,
                  set = "setPlaySound",
                  get = "getPlaySound",
              },
            groupSelect = {
              name = "When to Boost your Ego",
              type = "group",
              inline = true,
              order = 6,
			  disabled = function() return not EgoBooster.db.profile.isPlaySound end,
              args = {
                      soloOn = {
                            type = "toggle",
                            name = "Solo",
                            desc = "Boost your Ego when you are alone.",
                            set = "setSolo",
                            get = "getSolo",
                            order = 7,
                        },
                      partyOn = {
                            type = "toggle",
                            name = "Party / Raid",
                            desc = "Boost your Ego when you are in Party or Raid.",
                            set = "setParty",
                            get = "getParty",
                            order = 8,
                        },
                      },
              },

            egoBoostersSelect = {
              name = "Who will Boost your Ego",
              type = "group",
              inline = true,
              order = 10,
			  disabled = function() return not EgoBooster.db.profile.isPlaySound end,
              args = {
                        maleOn = {
                              type = "toggle",
                              name = "Male",
                              desc = "Male Voices",
                              get = function(info) return EgoBooster.db.profile.maleOn end,
                              set = function(info, value)
                                EgoBooster.db.profile.maleOn = value
                                setupFlirts()
                               end,
                              order = 1,
                          },
                        femaleOn = {
                              type = "toggle",
                              name = "Female",
                              desc = "Female Voices",
                              get = function(info) return EgoBooster.db.profile.femaleOn end,
                              set = function(info, value)
                                EgoBooster.db.profile.femaleOn = value
                                setupFlirts()
                               end,
                              order = 2,
                          },
                        selectAll = {
                              type = "toggle",
                              name = "Select / Deselect All",
                              desc = "Select or Deselect all the voices.",
                              get = function(info) return EgoBooster.db.profile.selectAll end,
                              set = function(info, value) EgoBooster.db.profile.selectAll = value
                                EgoBooster.db.profile.femaleOn = value
                                EgoBooster.db.profile.maleOn = value
                                EgoBooster.db.profile.BloodElf = value
                                EgoBooster.db.profile.demonHunterBlood = value
                                EgoBooster.db.profile.demonHunterNight = value
                                EgoBooster.db.profile.drenai = value
                                EgoBooster.db.profile.dwarf = value
                                EgoBooster.db.profile.gnome = value
                                EgoBooster.db.profile.goblin = value
                                EgoBooster.db.profile.human = value
                                EgoBooster.db.profile.nightElf = value
                                EgoBooster.db.profile.orc = value
                                EgoBooster.db.profile.pandaren = value
                                EgoBooster.db.profile.tauren = value
                                EgoBooster.db.profile.troll = value
                                EgoBooster.db.profile.undead = value
                                EgoBooster.db.profile.worgen = value
                                EgoBooster.db.profile.voidelf = value
                                EgoBooster.db.profile.lightdrenai = value
                                EgoBooster.db.profile.nightborn = value
                                EgoBooster.db.profile.hightaurents = value
                                setupFlirts()
                              end,
                              order = 2,
                          },

                          groupSelect = {
                            name = "Race",
                            type = "group",
                            inline = true,
                            order = 11,
                            args = {
                              BloodElf = {
                                    type = "toggle",
                                    name = "Blood Elf",
                                    desc = "Blood Elf Flirts",
                                    get = "getBloodElf",
                                    set = "setBloodElf",
                                    order = 1,
                                },
                              demonHunterBlood = {
                                    type = "toggle",
                                    name = "DH Blood Elf",
                                    desc = "Demon Hunter Blood Elf Flirts",
                                    get = "getdemonHunterBlood",
                                    set = "setdemonHunterBlood",
                                    order = 2,
                                },
                              demonHunterNight = {
                                    type = "toggle",
                                    name = "DH Night Elf",
                                    desc = "Demon Hunter Night Elf Flirts",
                                    get = "getdemonHunterNight",
                                    set = "setdemonHunterNight",
                                    order = 3,
                                },
                              drenai = {
                                    type = "toggle",
                                    name = "Drenai",
                                    desc = "Drenai Flirts",
                                    get = "getdrenai",
                                    set = "setdrenai",
                                    order = 4,
                                },
                              dwarf = {
                                    type = "toggle",
                                    name = "Dwarf",
                                    desc = "Dwarf Flirts",
                                    get = "getdwarf",
                                    set = "setdwarf",
                                    order = 5,
                                },
                              gnome = {
                                    type = "toggle",
                                    name = "Gnome",
                                    desc = "Gnome Flirts",
                                    get = "getgnome",
                                    set = "setgnome",
                                    order = 6,
                                },
                              goblin = {
                                    type = "toggle",
                                    name = "Goblin",
                                    desc = "Goblin Flirts",
                                    get = "getgoblin",
                                    set = "setgoblin",
                                    order = 7,
                                },
                              human = {
                                    type = "toggle",
                                    name = "Human",
                                    desc = "Human Flirts",
                                    get = "gethuman",
                                    set = "sethuman",
                                    order = 8,
                                },
                              nightElf = {
                                    type = "toggle",
                                    name = "Night Elf",
                                    desc = "Night Elf Flirts",
                                    get = "getnightElf",
                                    set = "setnightElf",
                                    order = 9,
                                },
                              orc = {
                                    type = "toggle",
                                    name = "Orc",
                                    desc = "Orc Flirts",
                                    get = "getorc",
                                    set = "setorc",
                                    order = 10,
                                },
                              pandaren = {
                                    type = "toggle",
                                    name = "Pandaren",
                                    desc = "Pandaren Flirts",
                                    get = "getpandaren",
                                    set = "setpandaren",
                                    order = 11,
                                },
                              tauren = {
                                    type = "toggle",
                                    name = "Tauren",
                                    desc = "Tauren Flirts",
                                    get = "gettauren",
                                    set = "settauren",
                                    order = 12,
                                },
                              troll = {
                                    type = "toggle",
                                    name = "Troll",
                                    desc = "Troll Flirts",
                                    get = "gettroll",
                                    set = "settroll",
                                    order = 13,
                                },
                              undead = {
                                    type = "toggle",
                                    name = "Undead",
                                    desc = "Undead Flirts",
                                    get = "getundead",
                                    set = "setundead",
                                    order = 14,
                                },
                              worgen = {
                                    type = "toggle",
                                    name = "Worgen",
                                    desc = "Worgen Flirts",
                                    get = "getworgen",
                                    set = "setworgen",
                                    order = 15,
                                },							
							  voidelf = {
									type = "toggle",
									name = "Void Elf",
									desc = "Void Elf Flirts",
									get = function(info) return EgoBooster.db.profile.voidelf end,
									set = function(info, value)
											EgoBooster.db.profile.voidelf = value
											setupFlirts()											
										  end,
									order = 16,
								},							
							  lightdrenai = {
									type = "toggle",
									name = "Lightforged Draenei",
									desc = "Lightforged Draenei Flirts",
									get = function(info) return EgoBooster.db.profile.lightdrenai end,
									set = function(info, value)
											EgoBooster.db.profile.lightdrenai = value
											setupFlirts()											
										  end,
									order = 17,
								},
							  nightborn = {
									type = "toggle",
									name = "Nightborn",
									desc = "Nightborn Flirts",
								    get = function(info) return EgoBooster.db.profile.nightborn end,
									set = function(info, value)
											EgoBooster.db.profile.nightborn = value
											setupFlirts()											
										  end,
									order = 18,
								},
							  hightaurents = {
									type = "toggle",
									name = "Highmountain Tauren",
									desc = "Highmountain Tauren Flirts",
									get = function(info) return EgoBooster.db.profile.hightaurents end,
									set = function(info, value)
											EgoBooster.db.profile.hightaurents = value
											setupFlirts()											
										  end,
									order = 18,
								},
                            },
                          },
                },


              },

            extraSounds = {
              name = "Extra Boosters",
              type = "group",
              order = 30,
              inline = true,
			  disabled = function() return not EgoBooster.db.profile.isPlaySound end,
              args = {
                sayWhatAgain = {
                      type = "toggle",
                      name = "Say What Again..",
                      get = function(info) return EgoBooster.db.profile.sayWhatAgain end,
                      set = function(info, value)
                        EgoBooster.db.profile.sayWhatAgain = value
                        setupFlirts()
                        if value == true then
                          PlaySoundFile(soundMap["saywhat"], EgoBooster.db.profile.soundChannel)
                        end
                      end,
                      order = 16,
                  },
                damnSon = {
                      type = "toggle",
                      name = "Damn Son..",
                      get = function(info) return EgoBooster.db.profile.damnSon end,
                      set = function(info, value)
                        EgoBooster.db.profile.damnSon = value
                        setupFlirts()
                        if value == true then
                          PlaySoundFile(soundMap["damnson"], EgoBooster.db.profile.soundChannel)
                        end
                      end,
                      order = 17,
                  },
                floatLike = {
                      type = "toggle",
                      name = "Float like a..",
                      get = function(info) return EgoBooster.db.profile.floatLike end,
                      set = function(info, value)
                         EgoBooster.db.profile.floatLike = value
                         setupFlirts()
                         if value == true then
                           PlaySoundFile(soundMap["floatlike"], EgoBooster.db.profile.soundChannel)
                         end
                       end,
                      order = 18,
                  },
                leeroy = {
                      type = "toggle",
                      name = "Leeroy..",
                      get = function(info) return EgoBooster.db.profile.leeroy end,
                      set = function(info, value)
                        EgoBooster.db.profile.leeroy = value
                        setupFlirts()
                        if value == true then
                          PlaySoundFile(soundMap["leeroy"], EgoBooster.db.profile.soundChannel)
                        end
                      end,
                      order = 19,
                  },
                noonehas = {
                      type = "toggle",
                      name = "No one..",
                      get = function(info) return EgoBooster.db.profile.noonehas end,
                      set = function(info, value)
                        EgoBooster.db.profile.noonehas = value
                        setupFlirts()
                        if value == true then
                          PlaySoundFile(soundMap["noonehas"], EgoBooster.db.profile.soundChannel)
                        end
                      end,
                      order = 20,
                  },
                thuglife = {
                      type = "toggle",
                      name = "Thug Life",
                      get = function(info) return EgoBooster.db.profile.thuglife end,
                      set = function(info, value)
                        EgoBooster.db.profile.thuglife = value
                        setupFlirts()
                        if value == true then
                          PlaySoundFile(soundMap["thuglife"], EgoBooster.db.profile.soundChannel)
                        end
                      end,
                      order = 21,
                  },
                yahoo = {
                      type = "toggle",
                      name = "Yahoo",
                      get = function(info) return EgoBooster.db.profile.yahoo end,
                      set = function(info, value)
                         EgoBooster.db.profile.yahoo = value
                         setupFlirts()
                         if value == true then
                           PlaySoundFile(soundMap["yahoo"], EgoBooster.db.profile.soundChannel)
                         end
                       end,
                      order = 22,
                  },
				whoami = {
                      type = "toggle",
                      name = "Who am I?!",
                      get = function(info) return EgoBooster.db.profile.whoami end,
                      set = function(info, value)
                         EgoBooster.db.profile.whoami = value
                         setupFlirts()
                         if value == true then
                           PlaySoundFile(soundMap["whoami"], EgoBooster.db.profile.soundChannel)
                         end
                       end,
                      order = 23,
                  },

              },
            },
			combatInfo = {
              name = "Combat Info",
              type = "group",
              order = 40,
              inline = true,
              args = {
				enableBB = {
                      type = "toggle",
                      name = "Enable",
                      get = function(info) return EgoBooster.db.profile.enablebb end,
                      set = function(info, value)
                        EgoBooster.db.profile.enablebb = value						
                      end,
                      order = 1,
                  },
				bbTypes = {
					name = "Types",
					type = "group",
					inline = true,
					order = 11,
					args = {
						polyBreak = {
							  type = "toggle",
							  name = "Crowd Control",
							  get = function(info) return EgoBooster.db.profile.cc end,
							  set = function(info, value)
								EgoBooster.db.profile.cc = value
							  end,
							  disabled = function() return not EgoBooster.db.profile.enablebb end, 
							  order = 1,
						  },
						interrupts = {
							  type = "toggle",
							  name = "Interrupt",
							  get = function(info) return EgoBooster.db.profile.interrupt end,
							  set = function(info, value)
								EgoBooster.db.profile.interrupt = value                  
							  end,
							  disabled = function() return not EgoBooster.db.profile.enablebb end, 
							  order = 2,
						  },
						misdirects = { 
							  type = "toggle",
							  name = "Misdirect",
							  get = function(info) return EgoBooster.db.profile.misdirect end,
							  set = function(info, value)
								EgoBooster.db.profile.misdirect = value                  
							  end,
							  disabled = function() return not EgoBooster.db.profile.enablebb end, 
							  order = 3,
						  },
						battleRes = { 
							  type = "toggle",
							  name = "Battle Res",
							  get = function(info) return EgoBooster.db.profile.battleres end,
							  set = function(info, value)
								EgoBooster.db.profile.battleres = value                  
							  end,
							  disabled = function() return not EgoBooster.db.profile.enablebb end, 
							  order = 4,
						  },
						taunts = { 
							  type = "toggle",
							  name = "Taunt",
							  get = function(info) return EgoBooster.db.profile.taunt end,
							  set = function(info, value)
								EgoBooster.db.profile.taunt = value                  
							  end,
							  disabled = function() return not EgoBooster.db.profile.enablebb end, 
							  order = 5,
						  },
						dispells = {
							  type = "toggle",
							  name = "Dispell",
							  get = function(info) return EgoBooster.db.profile.dispells end,
							  set = function(info, value)
								EgoBooster.db.profile.dispells = value                  
							  end,
							  disabled = function() return not EgoBooster.db.profile.enablebb end, 
							  order = 6,
						  },
					  },
				  },
				},
            },
    },
}



local phrases = {"Go get them Tiger!"}

local motivationPhrases = {
  "Our greatest glory is not in never falling, but in rising every time we fall.",
  "All our dreams can come true, if we have the courage to pursue them.",
  "It does not matter how slowly you go as long as you do not stop.",
  "Success is not final, failure is not fatal: it is the courage to continue that counts.",
  "Believe in yourself. You are braver than you think, more talented than you know, and capable of more than you imagine.",
  "It’s not whether you get knocked down. It’s whether you get up.",
  "Your true success in life begins only when you make the commitment to become excellent at what you do.",
  "If you believe it will work out, you’ll see opportunities. If you believe it won’t, you will see obstacles.",
  "Hard times don’t create heroes. It is during the hard times when the ‘hero’ within us is revealed.",
  "Believe you can and you’re halfway there.",
  "Your mind is a powerful thing. When you fill it with positive thoughts, your life will start to change.",
  "Start by doing what’s necessary; then do what’s possible; and suddenly you are doing the impossible.",
  "Whatever you hold in your mind on a consistent basis is exactly what you will experience in your life.",
  "Most of the important things in the world have been accomplished by people who have kept on trying when there seemed to be no hope at all.",
  "Strength does not come from physical capacity. It comes from an indomitable will.",
  "Perseverance is the hard work you do after you get tired of doing the hard work you already did.",
  "I am not a product of my circumstances. I am a product of my decisions.",
  "Don’t be pushed around by the fears in your mind. Be led by the dreams in your heart.",
  "You’re going to go through tough times – that’s life. But I say, ‘Nothing happens to you, it happens for you.’ See the positive in negative events.",
  "Character cannot be developed in ease and quiet. Only through experience of trial and suffering can the soul be strengthened, ambition inspired, and success achieved.",
  "Whatever the mind can conceive and believe, it can achieve.",
  "Don’t wish it were easier. Wish you were better. ",
  "It is during our darkest moments that we must focus to see the light.",
  "It’s not about perfect. It’s about effort. And when you bring that effort every single day, that’s where transformation happens. That’s how change occurs.",
  "Success is no accident. It is hard work, perseverance, learning, studying, sacrifice and most of all, love of what you are doing or learning to do.",
  "Strength doesn’t come from what you can do. It comes from overcoming the things you once thought you couldn’t.",
  "Fortune always favors the brave, and never helps a man who does not help himself.",
  "Go confidently in the direction of your dreams. Live the life you have imagined.",
  "The only person you are destined to become is the person you decide to be.",
  "Life is 10% what happens to you and 90% how you react to it.",
  "If you don’t like something, change it. If you can’t change it, change your attitude.",
  "Failure will never overtake me if my determination to succeed is strong enough.",
  "Limitations live only in our minds. But if we use our imaginations, our possibilities become limitless.",
  "Only those who dare to fail greatly can ever achieve greatly.",
  "Remember that not getting what you want is sometimes a wonderful stroke of luck.",
  "Staying positive does not mean that things will turn out okay. Rather it is knowing that you will be okay no matter how things turn out.",
  "No matter how hard times may get, always hold your head up and be strong; show them you’re not as weak as they think you are.",
  "We may encounter many defeats but we must not be defeated.", 
  "Believe in yourself! Have faith in your abilities! Without a humble but reasonable confidence in your own powers you cannot be successful or happy.",
  "Don't judge each day by the harvest you reap, but by the seeds that you plant.",
  "Perfection is not attainable, but if we chase perfection we can catch excellence.",
  "Put your heart, mind, and soul into even your smallest acts. This is the secret of success.",
  "To be the best, you must be able to handle the worst."
}

local soloBoostPhrases = {
	"You're simply the Best!",
	"OMG, you are Amazing!",
	"You are too good for this.",
	"Best Performance Ever!",
	"You are the most skilled Player!",
	"GODLIKE!",
	"People must be aware of the greatness that you are!",
	"Your Opponent was not worthy of You!",
	"You always know Exactly what to do!",
	"You showed them how it's done!",
	"You never get tired of this.",
	"Amazing, well Done!",
	"Epic performance!",
	"You should get achivement for that!",
	"You are a true HERO among us.",
	"Another one bites the dust!",
	"You did that very well",
	"Way to go!",
	"Outstanding!",
	"Fantastic!",
	"You outdid yourself today.",
	"You’re doing a good job!",
	"Well, look at you go!",
	"Tremendous!",
	"You must have been practicing!",
	"I knew you could do it!",
	"You make it look easy.",
	"You really make this fun!",
	"Nothing can stop you now!",
	"Sensational!",
	"I’ve never seen anyone do it better"
}

local escapePhrases = {
	"It wasn't worth your attention.",
	"You let them live, you are so kind.",
	"You have better things to do.",
	"You spared them, such kind soul you are.",
	"No time to fight, You are late for an appointment!",
	"It's alright, sometimes you just not in the mood to kick some tail.",
	"Correct Decision! That weakling is not worth your time.",
	"See you later Aligator!",
	"I forgot to switch off Kettle at home!",
	"Sorry go to go.",
	"Maybe another time."
}

local phrasesToUse = {};
local motivationToUse = {};
local escapesToUse = {};

function EgoBooster:getMsgColor(info)
  return self.db.profile.msgColor.R, self.db.profile.msgColor.G, self.db.profile.msgColor.B
end

function EgoBooster:setMsgColor(info, r, g, b)
  self.db.profile.msgColor.R = r
  self.db.profile.msgColor.G = g
  self.db.profile.msgColor.B = b
end

function EgoBooster:getBloodElf(info)
  return self.db.profile.BloodElf
end

function EgoBooster:setBloodElf(info, value)
  self.db.profile.BloodElf = value
  setupFlirts()
end

function EgoBooster:getdemonHunterBlood(info)
  return self.db.profile.demonHunterBlood
end

function EgoBooster:setdemonHunterBlood(info, value)
  self.db.profile.demonHunterBlood = value
  setupFlirts()
end

function EgoBooster:getdemonHunterNight(info)
  return self.db.profile.demonHunterNight
end

function EgoBooster:setdemonHunterNight(info, value)
  self.db.profile.demonHunterNight = value
  setupFlirts()
end

function EgoBooster:getdrenai(info)
  return self.db.profile.drenai
end

function EgoBooster:setdrenai(info, value)
  self.db.profile.drenai = value
  setupFlirts()
end

function EgoBooster:getdwarf(info)
  return self.db.profile.dwarf
end

function EgoBooster:setdwarf(info, value)
  self.db.profile.dwarf = value
  setupFlirts()
end

function EgoBooster:getgnome(info)
  return self.db.profile.gnome
end

function EgoBooster:setgnome(info, value)
  self.db.profile.gnome = value
  setupFlirts()
end

function EgoBooster:getgoblin(info)
  return self.db.profile.goblin
end

function EgoBooster:setgoblin(info, value)
  self.db.profile.goblin = value
  setupFlirts()
end

function EgoBooster:gethuman(info)
  return self.db.profile.human
end

function EgoBooster:sethuman(info, value)
  self.db.profile.human = value
  setupFlirts()
end

function EgoBooster:getnightElf(info)
  return self.db.profile.nightElf
end

function EgoBooster:setnightElf(info, value)
  self.db.profile.nightElf = value
  setupFlirts()
end

function EgoBooster:getorc(info)
  return self.db.profile.orc
end

function EgoBooster:setorc(info, value)
  self.db.profile.orc = value
  setupFlirts()
end

function EgoBooster:getpandaren(info)
  return self.db.profile.pandaren
end

function EgoBooster:setpandaren(info, value)
  self.db.profile.pandaren = value
  setupFlirts()
end

function EgoBooster:gettauren(info)
  return self.db.profile.tauren
end

function EgoBooster:settauren(info, value)
  self.db.profile.tauren = value
  setupFlirts()
end

function EgoBooster:gettroll(info)
  return self.db.profile.troll
end

function EgoBooster:settroll(info, value)
  self.db.profile.troll = value
  setupFlirts()
end

function EgoBooster:getundead(info)
  return self.db.profile.undead
end

function EgoBooster:setundead(info, value)
  self.db.profile.undead = value
  setupFlirts()
end

function EgoBooster:getworgen(info)
  return self.db.profile.worgen
end

function EgoBooster:setworgen(info, value)
  self.db.profile.worgen = value
  setupFlirts()
end

function EgoBooster:getisMsgEnabled(info)
   return self.db.profile.isMsgEnabled
end

function EgoBooster:setisMsgEnabled(info, value)
  self.db.profile.isMsgEnabled = value
end

function EgoBooster:setParty(info, value)
    self.db.profile.partyOn = value
end

function EgoBooster:getParty(info, value)
    return self.db.profile.partyOn
end

function EgoBooster:setSolo(info, value)
    self.db.profile.soloOn = value
end

function EgoBooster:getSolo(info, value)
  return self.db.profile.soloOn
end

function EgoBooster:getPlaySound(info, value)
    return self.db.profile.isPlaySound
end

function EgoBooster:setPlaySound(info, value)
    self.db.profile.isPlaySound = value
end

function EgoBooster:setSoundKey(info, value)
    self.db.profile.soundKey = value
    PlaySound(value, self.db.profile.soundChannel)
end

function EgoBooster:getSoundKey(info, value)
    return self.db.profile.soundKey
end

function EgoBooster:getTimeDelay(info)
    return self.db.profile.time_delay
end

function EgoBooster:setTimeDelay(info, value)
    self.db.profile.time_delay = value
end

function EgoBooster:setSoundChannel(info,value)
  self.db.profile.soundChannel = value
end

function EgoBooster:getSoundChannel(info)
  return self.db.profile.soundChannel
end

function EgoBooster:IsShowInChat(info)
    return self.db.profile.showInChat
end


function EgoBooster:OnInitialize()
    -- Called when the addon is loaded
	
	self.db = LibStub("AceDB-3.0"):New("EgoBoosterDB", defaults, true)

	self:RegisterChatCommand("rl", function() ReloadUI() end)
	self:RegisterChatCommand("eb", "Boosting")
	self:RegisterEvent("PLAYER_REGEN_ENABLED","combatEnded")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "readCombatLog");
	self:RegisterEvent("PLAYER_REGEN_DISABLED", "enterCombatChecks")
	
	LibStub("AceConfig-3.0"):RegisterOptionsTable("EgoBooster", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("EgoBooster", "EgoBooster")
end


function EgoBooster:OnEnable()
  -- Called when the addon is enabled
  self:Print("type /eb for settings.")
  setupFlirts()  
end

function EgoBooster:OnDisable()
    -- Called when the addon is disabled
end


function EgoBooster:Boosting(input)
  -- Process the slash command ('input' contains whatever follows the slash command)
  InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
  InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
end

function refillPhrases(sourceArr, destArr)
	for k,v in pairs(sourceArr) do
		--print(k,v)
		table.insert(destArr, #destArr, v)
	end

end

local function cleanDefeatedList()
	cleaningIsRunning = true
	local cleanTimer = CreateFrame("Frame")
	local ONUPDATE_INTERVAL = 10
	local TimeSinceLastUpdate = 0
	--print("starting cleaning")
	cleanTimer:SetScript("OnUpdate", function(self, elapsed)
		TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed
		if TimeSinceLastUpdate >= ONUPDATE_INTERVAL then
			TimeSinceLastUpdate = 0
			--print("cleaning pool")
			for index, idTime in pairs(defeatedEnemiesList) do
				local timeToErase = tonumber(strmatch(idTime, ">>>(%d+)"))
				if timeToErase < time() then
					--print("remove from defeat")
					table.remove(defeatedEnemiesList, index)
				end
			end
			
			if not playerInCombat then
				--print("stopping cleaning")
				cleaningIsRunning = false
				defeatedEnemiesList = {}
				cleanTimer:SetScript("OnUpdate", nil)					
				cleanTimer:UnregisterAllEvents()
			end
		end
	end)

end

local function resetCombatData()
	playerInCombat = false
	playersInCombat = {}
	enemiesInCombat = {}
	bossesInCombat = {}
	runningCombatCheck = false
	fightHadBosses = false
	fightHadEnemies = false
	playersWereInCombat = false
	maxDefeated = 0
end

function EgoBooster:enterCombatChecks(input)

	resetCombatData()

	playerInCombat = true 
	if not cleaningIsRunning then
		cleanDefeatedList()
	end
	
end

function playRandomSound()
  local rSnd = 0
  local counter = 1
  local flirtKey = ""

  for k, v in pairs(flirtingSoundsToUse) do
    rSnd = rSnd + 1
  end

  rSnd = fastrandom(1, rSnd)

  for k, v in pairs(flirtingSoundsToUse) do
    --print(k)
    if counter == rSnd then
      flirtKey = k
	  --print("playing", flirtKey)
      local testFile = string.sub(flirtKey,0,9)
      if testFile == "Interface" then
        PlaySoundFile(flirtKey, EgoBooster.db.profile.soundChannel)
        return
      else
        PlaySound(flirtKey, EgoBooster.db.profile.soundChannel)
        return
      end
    end
    counter = counter + 1
  end


end

local plyrMsk = bit.bor(bit.bor(COMBATLOG_OBJECT_TYPE_PET, COMBATLOG_OBJECT_TYPE_PLAYER), COMBATLOG_OBJECT_TYPE_GUARDIAN) 

local function spellInList(spellID, spellList)
	for _, v in pairs(spellList) do
		if v == spellID then
			return true
		end
	end
	return false
end		

local OldSetItemRef = SetItemRef 
function SetItemRef(link, text, button, chatFrame) 
--print(link)
	local customMsg = strmatch(link, "::CombatInfo:(.+)") 
	if customMsg then 
		local msgTime = strmatch(customMsg, "(.+):") 
		msgTime = date("%H:%M:%S", msgTime)
		local msgText = strmatch(customMsg, ":(.+)") 
		
		local spellLink = strmatch(msgText, "<<<(%d+)>>>") 
		if spellLink then			
			spellLink = GetSpellLink(spellLink)
			msgText = string.gsub(msgText, "<<<(%d+)>>>", spellLink)
		end
		
		local spellLink2 = strmatch(msgText, ">>>(%d+)<<<") 
		if spellLink2 then			
			spellLink2 = GetSpellLink(spellLink2)
			msgText = string.gsub(msgText, ">>>(%d+)<<<", spellLink2)
		end
	
		local chatType = "PARTY"
		
		if not IsInGroup(2) then
			if IsInRaid() then
				chatType = "RAID"
			elseif IsInGroup(1) then
				chatType = "PARTY"
			end	
		elseif IsInGroup(2) then
			chatType = "INSTANCE_CHAT" 
		end
		
		SendChatMessage(msgTime .. " [Info]: ".. msgText, chatType, nil, nil )
	else 
	OldSetItemRef(link, text, button, chatFrame) 
	end 
end 		

local ccdetails = {
  timer = {},          
  spID = {},      
  delayTime = {},  
  dmgSPID = {},   
  dmgSPName = {},    
  dmgUID = {},   
  dmgUName = {},   
  dmgUFlgs = {},  
  dmgURFlgs = {}, 
}
local function ccdetailsClear(destID) 
      ccdetails.timer[destID] = nil
      ccdetails.spID[destID] = nil
      ccdetails.delayTime[destID] = nil
      ccdetails.dmgSPID[destID] = nil
      ccdetails.dmgSPName[destID] = nil
      ccdetails.dmgUID[destID] = nil
      ccdetails.dmgUName[destID] = nil
      ccdetails.dmgUFlgs[destID] = nil
      ccdetails.dmgURFlgs[destID] = nil
end  

local function unitColor(guid)
	--locClass, engClass, locRace, engRace, gender = GetPlayerInfoByGUID("guid")
	_, class = GetPlayerInfoByGUID(guid)
	if class and RAID_CLASS_COLORS[class] then
		local c = RAID_CLASS_COLORS[class]
		return string.format("\124cff%02x%02x%02x", c.r*255, c.g*255, c.b*255)
	else
		-- unknown
		return "\124r\124h\124h"
	end
end


local nextMsgTime = time()

function EgoBooster:readCombatLog(event)

	local _, t, _, sourceID, sourceName, sourceFlags, sourceRaidFlags, destID, destName, destFlags, _, spellID, spName, _, ext1, ext2, ext3 = CombatLogGetCurrentEventInfo()	
	--print(t, sourceName, destName)

	if not EgoBooster.db.profile.enablebb then
		-- CombatInfo disabled
		return
	end
	
	-- ignore pvp
	if UnitIsPVP("player") then
		return
	end
				  
	if ( destID == UnitGUID("player") and sourceID ~= UnitGUID("player") ) 
		or ( destID ~= UnitGUID("player") and sourceID == UnitGUID("player") ) then
		playerInCombat = true
	end
	
	if not playerInCombat then
		return
	end
	
	-- skip actions from defeated enemies
	for _, defID in pairs(defeatedEnemiesList) do
		local filterID = strmatch(defID, "(.+)>>>")
		if filterID == destID or filterID == sourceID then
			return
		end
	end

	--skip outsiders
	if bit.band(sourceFlags, COMBATLOG_OBJECT_AFFILIATION_OUTSIDER) > 0
		and bit.band(destFlags, COMBATLOG_OBJECT_AFFILIATION_OUTSIDER) > 0 then
		return
	end
	
	-- skip events that have nil values for src or dst, but allow death events
	if t ~= "PARTY_KILL" and t ~= "UNIT_DIED" and t ~= "UNIT_DESTROYED" and t ~= "UNIT_DISSIPATES" and not string.find(t, "_INSTAKILL")
		and (not sourceName or not destName ) then
		return
	end

	-- skip if self buffs or auras
	if sourceID == destID or sourceName == destName then
		return
	end


	local hostileDest = bit.band(destFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0
	local hostileSource = bit.band(sourceFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0
	
	local playerSource = bit.band(sourceFlags, plyrMsk) > 0
	local playerDest = bit.band(destFlags, COMBATLOG_OBJECT_TYPE_PLAYER) > 0  
	
	local yellow = RGBPercToHex(0.95, 0.87, 0.26)
	local green = RGBPercToHex(0.26, 0.95, 0.57)
	
	local isPlayer = bit.band(sourceFlags, COMBATLOG_OBJECT_TYPE_PLAYER) > 0
	
	local isInList = false
	
	--print(t, sourceName, destName)
	
	if isPlayer then
		for _, v in pairs(playersInCombat) do
			if v == sourceID then
				isInList = true
				break
			end
		end
	end
	
	if not isInList and isPlayer then
		--print("add new player", sourceName)
		playersWereInCombat = true
		table.insert(playersInCombat, sourceID)
	end
	
	local enemyInList = false
	
	local enemyIDToCheck = destID
	if not playerSource and sourceName then
		enemyIDToCheck = sourceID
	end
	
	local isUnitKilled = false
	
	if t == "PARTY_KILL" or t == "UNIT_DIED" or t == "UNIT_DESTROYED" or t == "UNIT_DISSIPATES" or string.find(t, "_INSTAKILL") then
		isUnitKilled = true
		--print("killed", destName, ":", sourceName)
	end
	
	if not isUnitKilled and (hostileDest or hostileSource) and not string.find(enemyIDToCheck, "Player") then
	
		local updateEnemyIndex
	
		for i, v in pairs(enemiesInCombat) do 
			if v == enemyIDToCheck then
				updateEnemyIndex = i
				enemyInList = true
				break
			end
		end
		
		if not enemyInList then
		
			for _, v in pairs(bossesInCombat) do 
				if v == enemyIDToCheck then
					enemyInList = true
					break
				end
			end
			
		else 
			-- check if enemy was boss and update Lists
			for i=1, 10 do
				if enemyIDToCheck == UnitGUID("boss"..i) then
					--print("change to boss", destName, ":", sourceName, enemyIDToCheck)
					isEnemyBoss = true
					fightHadBosses = true
					table.insert(bossesInCombat, enemyIDToCheck)
					table.remove(enemiesInCombat,updateEnemyIndex)	
					if #enemiesInCombat == 0 then
						fightHadEnemies = false
					end
				end
			end
		end
		
	end
	
	if not enemyInList and not isUnitKilled and (hostileDest or hostileSource) 
		and not string.find(enemyIDToCheck, "Player") 
		and not ( string.find(destName, "Explosives") or string.find(sourceName, "Explosives") )	-- Ignore Explosives Affix
		then
		--print("add enemy")
		local isEnemyBoss = false
		
		for i=1, 10 do
			if enemyIDToCheck == UnitGUID("boss"..i) then
				--print("add boss", t, destName, ":", sourceName, "=", enemyIDToCheck)
				isEnemyBoss = true
				fightHadBosses = true
				table.insert(bossesInCombat, enemyIDToCheck)
			end
		end
		
		if not isEnemyBoss then
			--print("add enemy", t, destName, ":", sourceName, "=", enemyIDToCheck)
			table.insert(enemiesInCombat, enemyIDToCheck)
			fightHadEnemies = true
			maxDefeated = maxDefeated + 1
		end
		
	end
	
	if isUnitKilled and (hostileDest or hostileSource) and not string.find(enemyIDToCheck, "Player") then
		local enemyListPos = -1
		local foundEnemy = false
		
		for i, eid in pairs(enemiesInCombat) do
			if eid == enemyIDToCheck then
				--print("removing enemy", enemyIDToCheck)
				foundEnemy = true
				local idWithResetTime = enemyIDToCheck .. ">>>" .. time() + 15
				table.insert(defeatedEnemiesList, idWithResetTime)
				table.remove(enemiesInCombat, i)	
			end
		end
		
		if not foundEnemy then
			for i, eid in pairs(bossesInCombat) do
				if eid == enemyIDToCheck then
					--print("removing boss", enemyIDToCheck)
					local idWithResetTime = enemyIDToCheck .. ">>>" .. time() + 15
					table.insert(defeatedEnemiesList, idWithResetTime)
					table.remove(bossesInCombat, i)	
				end
			end
		end
	end
		
	-- Combat Info
	
	local newCCDmg = (t == "SPELL_AURA_APPLIED" and (not ccdetails.dmgSPID[destID] or ccdetails.dmgSPID[destID] == 0)
			and not spellInList(spellID, SpellsInfo.aoet) and not spellInList(spellID, SpellsInfo.ccaura)
			and not spellInList(spellID, SpellsInfo.cc) and not spellInList(spellID, SpellsInfo.taunt))
	
	-- crowd control damage
	if EgoBooster.db.profile.cc then
		if  ccdetails.timer[destID] and destID and (string.find(t, "_DAMAGE") or newCCDmg ) and spellID ~= 66070 then 
		    --print("new cc dmg")
			local newSPName, newSPID
			
			if t == "SWING_DAMAGE" then
				newSPName = "melee attack"
				newSPID = 6603 
			elseif t == "SPELL_AURA_APPLIED" then
				newSPName = spName
				newSPID = spellID 
			else
				newSPName = spName
				newSPID = ext1 
			end
			
			ccdetails.dmgSPID[destID] = ccdetails.dmgSPID[destID] or 0
			
			if (ccdetails.dmgSPID[destID] == 0 and newSPID > 0) or newSPID > 0 then
				ccdetails.dmgSPID[destID] = newSPID
				ccdetails.dmgSPName[destID] = newSPName
				ccdetails.dmgUID[destID] = sourceID
				ccdetails.dmgUName[destID] = sourceName
				ccdetails.dmgUFlgs[destID] = sourceFlags
				ccdetails.dmgURFlgs[destID] = sourceRaidFlags
			end
			
			if ccdetails.dmgSPID[destID] > 0 and ccdetails.delayTime[destID] then
				if (GetTime() - ccdetails.delayTime[destID]) < 0.5 then 
					t = "SPELL_AURA_BROKEN_SPELL"
					ext1 = spellID
					ext2 = spName
				else 
					t = "SPELL_AURA_REMOVED"
				end
				spellID = ccdetails.spID[destID]
				spName = GetSpellInfo(spellID)
			end
		  
		elseif hostileDest and playerSource and (t == "SPELL_AURA_REFRESH" or t == "SPELL_AURA_APPLIED") and spellID ~= 24131 and spellInList(spellID, SpellsInfo.cc) then
				--print("new cc")
				local duration = 60
				if not SpellsInfo.cctime[spellID] then
					print("new CC AURA, tell developer:", spellID, spName)
				else 
					duration = SpellsInfo.cctime[spellID]
				end
				local expires = GetTime() + duration
				local now = GetTime()		
				
				ccdetailsClear(destID)  
				ccdetails.timer[destID] = expires
				ccdetails.spID[destID] = spellID
		end
		
		-- crowd controll broken
		if (t == "SPELL_AURA_BROKEN_SPELL" or t == "SPELL_AURA_BROKEN" or t == "SPELL_AURA_REMOVED") and spellID ~= 24131 and hostileDest and spellInList(spellID, SpellsInfo.cc) then
			local now = GetTime();
			local expired = false
			--print("broken cc")
			if spellID == ccdetails.spID[destID] then 
			  if ccdetails.timer[destID] and (ccdetails.timer[destID] - now < 1) then
				  expired = true
			  elseif spellID == 710 then 
				  t = "SPELL_AURA_REMOVED"
			  elseif ccdetails.timer[destID] and (ccdetails.timer[destID] - now > 1) and ccdetails.dmgSPName[destID] and t ~= "SPELL_AURA_BROKEN_SPELL" then
					t = "SPELL_AURA_BROKEN_SPELL"				
					sourceID = ccdetails.dmgUID[destID]
					sourceName = ccdetails.dmgUName[destID]
					sourceFlags = ccdetails.dmgUFlgs[destID]
					sourceRaidFlags = ccdetails.dmgURFlgs[destID]
					ext1 = ccdetails.dmgSPID[destID]				
					ext2 = ccdetails.dmgSPName[destID]
			  elseif t == "SPELL_AURA_REMOVED" and not ccdetails.delayTime[destID] then
				  ccdetails.delayTime[destID] = now
				  return
			  end
			  ccdetailsClear(destID)  
			end
			
			if t == "SPELL_AURA_BROKEN" then
				local chatMsg = "<<<"..spellID..">>> on " .. destName .. " removed by " .. sourceName
				local playerMsg = GetSpellLink(spellID) .. "\124r\124h\124h on \124cffff0000" .. destName .."\124r\124h\124h removed by " .. unitColor(sourceID) .. sourceName
				if nextMsgTime < time() then
					print("\124Hplayer::CombatInfo:"..time()..":"..chatMsg.."\124h\124cff8888ff[Info]\124r\124h\124h: " .. playerMsg)
					nextMsgTime = time() + 1
				end
				
			elseif t == "SPELL_AURA_BROKEN_SPELL" then
				local chatMsg = "<<<"..spellID..">>> on " .. destName .. " removed by " .. sourceName .."'s " .. ">>>"..ext1.."<<<"
				local playerMsg = GetSpellLink(spellID) .. "\124r\124h\124h on \124cffff0000" .. destName .."\124r\124h\124h removed by " .. unitColor(sourceID) .. sourceName .. "'s " .. GetSpellLink(ext1)
				if nextMsgTime < time() then
					print("\124Hplayer::CombatInfo:"..time()..":"..chatMsg.."\124h\124cff8888ff[Info]\124r\124h\124h: " .. playerMsg)
					nextMsgTime = time() + 1
				end
				
			elseif expired then 
				local chatMsg = "<<<"..spellID.. ">>> on " .. destName .. " expired"
				local playerMsg = GetSpellLink(spellID) .. "\"\124r\124h\124h on \124cffff0000" .. destName .."\124r\124h\124h expired"
				if nextMsgTime < time() then
					print("\124Hplayer::CombatInfo:"..time()..":"..chatMsg.."\124h\124cff8888ff[Info]\124r\124h\124h: " .. playerMsg)
					nextMsgTime = time() + 1
				end
				
			elseif t == "SPELL_AURA_REMOVED" then 			
				local chatMsg = "<<<"..spellID.. ">>> on " .. destName .. " removed"
				local playerMsg = GetSpellLink(spellID) .. "\"\124r\124h\124h on \124cffff0000" .. destName .."\124r\124h\124h removed"
				if nextMsgTime < time() then
					print("\124Hplayer::CombatInfo:"..time()..":"..chatMsg.."\124h\124cff8888ff[Info]\124r\124h\124h: " .. playerMsg)
					nextMsgTime = time() + 1
				end
				
			end
	  
		end
	end 
	
	-- interrupt
	if t=="SPELL_INTERRUPT" then
		local chatMsg = sourceName .. " interrupted <<<" .. ext1 .. ">>> on " .. destName .. " with >>>" .. spellID .. "<<<"
		local playerMsg = unitColor(sourceID) .. sourceName .. "\124r\124h\124h interrupted " .. GetSpellLink(ext1) .. "\124r\124h\124h on \124cffff0000" .. destName .. "\124r\124h\124h with " .. GetSpellLink(spellID)
		print("\124Hplayer::CombatInfo:"..time()..":"..chatMsg.."\124h\124cff8888ff[Info]\124r\124h\124h: " .. playerMsg)		
	end
	
	-- misdirect
	if t == "SPELL_CAST_SUCCESS" and ( spellID == 110588 or spellID == 57934 or spellID == 34477) then
		local chatMsg = sourceName .. " cast <<<" .. spellID .. ">>> on " .. destName
		local playerMsg = unitColor(sourceID) .. sourceName .. "\124r\124h\124h cast " .. GetSpellLink(spellID) .. "\124r\124h\124h on " .. unitColor(destID) .. destName
		print("\124Hplayer::CombatInfo:"..time()..":"..chatMsg.."\124h\124cff8888ff[Info]\124r\124h\124h: " .. playerMsg)
	end
	
	-- battle Res
	if t == "SPELL_RESURRECT" then		
		if spellInList(spellID, SpellsInfo.br) then
			local chatMsg = sourceName .. " ressurected " .. destName .. " with <<<" .. spellID .. ">>>"
			local playerMsg = unitColor(sourceID) .. sourceName .. "\124r\124h\124h ressurected " .. unitColor(destID) .. destName .. "\124r\124h\124h with " .. GetSpellLink(spellID)
			print("\124Hplayer::CombatInfo:"..time()..":"..chatMsg.."\124h\124cff8888ff[Info]\124r\124h\124h: " .. playerMsg)			
		end
	end
	
	-- missed taunt
	local missedWithTaunt = false
	if t == "SPELL_MISSED" then
		if ( spellInList(spellID, SpellsInfo.taunt) or spellInList(spellID, SpellsInfo.aoet) ) and not (spellID == 49576 and ext1 == "IMMUNE") and not playerDest then
			missedWithTaunt = true
			local chatMsg = sourceName .. " taunt failed on " .. destName .. " with <<<" .. spellID .. ">>>"
			local playerMsg = unitColor(sourceID) .. sourceName .. "\124r\124h\124h taunt failed on \124cffff0000" .. destName .. "\124r\124h\124h with " .. GetSpellLink(spellID)
			print("\124Hplayer::CombatInfo:"..time()..":"..chatMsg.."\124h\124cff8888ff[Info]\124r\124h\124h: " .. playerMsg)			
		end
	end
	
	-- taunt
	if t == "SPELL_CAST_SUCCESS" and spellInList(spellID, SpellsInfo.taunt) and not playerDest and not missedWithTaunt then
		local chatMsg = sourceName .. " taunted " .. destName .. " with <<<" .. spellID .. ">>>"
		local playerMsg = unitColor(sourceID) .. sourceName .. "\124r\124h\124h taunted \124cffff0000" .. destName .. "\124r\124h\124h with " .. GetSpellLink(spellID)
		print("\124Hplayer::CombatInfo:"..time()..":"..chatMsg.."\124h\124cff8888ff[Info]\124r\124h\124h: " .. playerMsg)		
	end
	
	-- dispell
	if t == "SPELL_DISPEL" and hostileDest then
		local chatMsg = sourceName .. " dispelled <<<" .. ext1 .. ">>> on " .. destName .. " with >>>" .. spellID .. "<<<"
		local playerMsg = unitColor(sourceID) .. sourceName .. "\124r\124h\124h dispelled " .. GetSpellLink(ext1) .. "\124r\124h\124h on \124cffff0000" .. destName .. "\124r\124h\124h with " .. GetSpellLink(spellID)
		print("\124Hplayer::CombatInfo:"..time()..":"..chatMsg.."\124h\124cff8888ff[Info]\124r\124h\124h: " .. playerMsg)				
	end
	
	-- dispell stolen
	if t == "SPELL_STOLEN" and hostileDest then
		local chatMsg = sourceName .. " stole <<<" .. ext1 .. ">>> from " .. destName .. " with >>>" .. spellID .. "<<<"
		local playerMsg = unitColor(sourceID) .. sourceName .. "\124r\124h\124h stole " .. GetSpellLink(ext1) .. "\124r\124h\124h from \124cffff0000" .. destName .. "\124r\124h\124h with " GetSpellLink(spellID)
		print("\124Hplayer::CombatInfo:"..time()..":"..chatMsg.."\124h\124cff8888ff[Info]\124r\124h\124h: " .. playerMsg)			
	end
	
end

function EgoBooster:printLogMsg(msg)

	local hex = RGBPercToHex(EgoBooster.db.profile.msgColor.R, EgoBooster.db.profile.msgColor.G, EgoBooster.db.profile.msgColor.B)
	
	hex = RGBPercToHex(0.95, 0.87, 0.26)
	print(hex..msg)
end

local function isInList(list, needle)
	for _, v in pairs(list) do
		if v == needle then
			return true
		end
	end
	return false
end

local function sendNewMessage(phrasesToUse, victory)
	--print("new msg")
	local playerNumber = GetNumGroupMembers()
	
	if isMsgDisplayed == false then
	
		local soloPartyCheck = false

		if ( (EgoBooster.db.profile.soloOn == true) and (playerNumber == 0) ) then
			soloPartyCheck = true
		end

		if ( (EgoBooster.db.profile.partyOn == true) and (playerNumber > 0) ) then
			soloPartyCheck = true
		end
		
		if EgoBooster.db.profile.isMsgEnabled == true then
			if soloPartyCheck == true then	
				--print("sending msg")
				local choice = math.random(#phrasesToUse);
				local hex = RGBPercToHex(EgoBooster.db.profile.msgColor.R, EgoBooster.db.profile.msgColor.G,EgoBooster.db.profile.msgColor.B)
				EgoBooster:Print(hex..phrasesToUse[choice])
				table.remove(phrasesToUse, choice)
				sendBubble("timer");
			end
		end -- if send msg enabled
		
		if EgoBooster.db.profile.isPlaySound == true and victory == true then
			if soloPartyCheck == true then
				playRandomSound();
			end
		end
	
	end -- can send new message
	
end

local function checkCombatEnded()

	if (#enemiesInCombat == 0 and not fightHadBosses) or #playersInCombat == 0 or (#bossesInCombat == 0 and fightHadBosses) then
		return true
	end
	
	local playerCount = GetNumGroupMembers()
	local unitID = "party"
	local stillCombat = false
	
	if IsInRaid() then
		unitID = "raid"
	end

	for i=1, playerCount do 
		local check = UnitAffectingCombat(unitID .. i)
		if UnitAffectingCombat(unitID .. i) then
			stillCombat = true
			break
		end
	end

	if not stillCombat then
		return true
	end
	
	return false
end

local function checkCombat()
	local timerCheck = CreateFrame("Frame")
	local ONUPDATE_INTERVAL = 0.5
	local TimeSinceLastUpdate = 0
	
	timerCheck:SetScript("OnUpdate", function(self, elapsed)
		TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed
		if TimeSinceLastUpdate >= ONUPDATE_INTERVAL then
			TimeSinceLastUpdate = 0
			--print("tick")
			if checkCombatEnded() then
				playerInCombat = false
				timerCheck:SetScript("OnUpdate", nil)			
				timerCheck:UnregisterAllEvents()
				EgoBooster:combatEnded()
			end
			
		end
	end)

end


function EgoBooster:combatEnded(input)

	if playerInCombat and GetNumGroupMembers() > 0 then
		if not runningCombatCheck then
			checkCombat()
			runningCombatCheck = true
		end
		return
	end
	
	if isMsgDisplayed and not EgoBooster.db.profile.alwaysShowKilledEnemies then
		--print("ignore msg")
		resetCombatData()
		return
	end
	
	--print("player in combat",playerInCombat)
	--print("enemies in combat", #enemiesInCombat)
	--print("players in combat", #playersInCombat)
	--print("bosses in combat", #bossesInCombat)
	--print("had bosses", fightHadBosses)
	--print("had enemies", fightHadEnemies)
	
	-- with special case when insta killed and it shows enemy 0 player 0 but player combat true
	if (#enemiesInCombat == 0 and #playersInCombat > 0 and not fightHadBosses and fightHadEnemies) or (#bossesInCombat == 0 and fightHadBosses and #playersInCombat > 0)
	 then
		-- only victory if players participated in the fight
		if #playersInCombat > 0 then
		
			if #phrasesToUse == 0 then
				refillPhrases(soloBoostPhrases,phrasesToUse);
			end
			
			sendNewMessage(phrasesToUse, true)
			if maxDefeated > 1 then
				local defMsg = "You have defeated " .. maxDefeated .. " enemies"
				local bossMsg = ""
				
				if fightHadBosses then
					bossMsg = " and the Boss"
				end
				EgoBooster:printLogMsg(defMsg .. bossMsg .. ".")
			end
		end
		
	else
				
		if #motivationToUse == 0 then
			refillPhrases(motivationPhrases, motivationToUse);
		end
		
		if #escapesToUse == 0 then
			refillPhrases(escapePhrases, escapesToUse);
		end
		
		if (#enemiesInCombat > 0 or #bossesInCombat > 0) and playersWereInCombat then
			sendNewMessage(motivationToUse, false)
		elseif not UnitIsDeadOrGhost("player") and ( #enemiesInCombat > 0 or #bossesInCombat > 0 ) and GetNumGroupMembers() == 0 then
			sendNewMessage(escapesToUse, false)
		end
		
	end
	
	resetCombatData()
	
end

function RGBPercToHex(r, g, b)
	r = r <= 1 and r >= 0 and r or 0
	g = g <= 1 and g >= 0 and g or 0
	b = b <= 1 and b >= 0 and b or 0
	return string.format("\124cFF%02x%02x%02x", r*255, g*255, b*255)
end

function sendBubble(phraseArr)

	if isMsgDisplayed == false then
		isMsgDisplayed = true;
		local choice = 0
		local offSet = 10
      
		local redColor = EgoBooster.db.profile.msgColor.R
		local greenColor = EgoBooster.db.profile.msgColor.G
		local blueColor = EgoBooster.db.profile.msgColor.B

		local statusbar = CreateFrame("StatusBar", "myTimerBar", UIParent)
      
		statusbar:SetPoint("CENTER", UIParent, "CENTER", 0, 400)
      
		statusbar:SetWidth(30)
    	statusbar:SetHeight(30)

		function statusbar:onUpdate(sinceLastUpdate)
			self.sinceLastUpdate = (self.sinceLastUpdate or 0) + sinceLastUpdate;
			statusbar:SetAlpha((7-self.sinceLastUpdate)*0.5);
			if ( self.sinceLastUpdate >= EgoBooster.db.profile.time_delay ) then -- in seconds				
				  --print("msg ended")
					statusbar:SetScript("OnUpdate", nil)
					statusbar:Hide()
					statusbar:SetParent(nil)
					statusbar:UnregisterAllEvents()
					statusbar:SetID(0)
					statusbar:ClearAllPoints()
					isMsgDisplayed = false;
					return
			end
		end
		
		statusbar:SetScript("OnUpdate",statusbar.onUpdate)

	end

end


function setupFlirts()
  --print("setting Flirts")

  if EgoBooster.db.profile.BloodElf == true then
    if EgoBooster.db.profile.femaleOn == true then
      flirtingSoundsToUse["9642"] = "Bloodelf Female"
    else
      flirtingSoundsToUse["9642"] = nil
    end
    if EgoBooster.db.profile.maleOn == true then
      flirtingSoundsToUse["9659"] = "Bloodelf Male"
    else
      flirtingSoundsToUse["9659"] = nil
    end
  else
    flirtingSoundsToUse["9642"] = nil
    flirtingSoundsToUse["9659"] = nil
  end

  if EgoBooster.db.profile.demonHunterBlood == true then
    if EgoBooster.db.profile.femaleOn == true then
      flirtingSoundsToUse["55567"] = "demonHunterBlood Female"
    else
      flirtingSoundsToUse["55567"] = nil
    end
    if EgoBooster.db.profile.maleOn == true then
      flirtingSoundsToUse["56537"] = "demonHunterBlood Male"
    else
      flirtingSoundsToUse["56537"] = nil
    end
  else
    flirtingSoundsToUse["55567"] = nil
    flirtingSoundsToUse["56537"] = nil
  end

  if EgoBooster.db.profile.demonHunterNight == true then
    if EgoBooster.db.profile.femaleOn == true then
      flirtingSoundsToUse["56157"] = "demonHunterNight Female"
    else
      flirtingSoundsToUse["56157"] = nil
    end
    if EgoBooster.db.profile.maleOn == true then
      flirtingSoundsToUse["56292"] = "demonHunterNight Male"
    else
      flirtingSoundsToUse["56292"] = nil
    end
  else
    flirtingSoundsToUse["56157"] = nil
    flirtingSoundsToUse["56292"] = nil
  end


  if EgoBooster.db.profile.drenai == true then
    if EgoBooster.db.profile.femaleOn == true then
      flirtingSoundsToUse["9684"] = "drenai Female"
    else
      flirtingSoundsToUse["9684"] = nil
    end
    if EgoBooster.db.profile.maleOn == true then
      flirtingSoundsToUse["9709"] = "drenai Male"
    else
      flirtingSoundsToUse["9709"] = nil
    end
  else
    flirtingSoundsToUse["9684"] = nil
    flirtingSoundsToUse["9709"] = nil
  end


  if EgoBooster.db.profile.dwarf == true then
    if EgoBooster.db.profile.femaleOn == true then
      flirtingSoundsToUse["6105"] = "dwarf Female"
    else
      flirtingSoundsToUse["6105"] = nil
    end
    if EgoBooster.db.profile.maleOn == true then
      flirtingSoundsToUse["6114"] = "dwarf Male"
    else
      flirtingSoundsToUse["6114"] = nil
    end
  else
    flirtingSoundsToUse["6105"] = nil
    flirtingSoundsToUse["6114"] = nil
  end

  if EgoBooster.db.profile.gnome == true then
    if EgoBooster.db.profile.femaleOn == true then
      flirtingSoundsToUse["6123"] = "Gnome Female"
    else
      flirtingSoundsToUse["6123"] = nil
    end
    if EgoBooster.db.profile.maleOn == true then
      flirtingSoundsToUse["6132"] = "Gnome Male"
    else
      flirtingSoundsToUse["6132"] = nil
    end
  else
    flirtingSoundsToUse["6123"] = nil
    flirtingSoundsToUse["6132"] = nil
  end

  if EgoBooster.db.profile.goblin == true then
    if EgoBooster.db.profile.femaleOn == true then
      flirtingSoundsToUse["19240"] = "goblin Female"
    else
      flirtingSoundsToUse["19240"] = nil
    end
    if EgoBooster.db.profile.maleOn == true then
      flirtingSoundsToUse["19131"] = "goblin Male"
    else
      flirtingSoundsToUse["19131"] = nil
    end
  else
    flirtingSoundsToUse["19240"] = nil
    flirtingSoundsToUse["19131"] = nil
  end

  if EgoBooster.db.profile.human == true then
    if EgoBooster.db.profile.femaleOn == true then
      flirtingSoundsToUse["6142"] = "human Female"
    else
      flirtingSoundsToUse["6142"] = nil
    end
    if EgoBooster.db.profile.maleOn == true then
      flirtingSoundsToUse["6169"] = "human Male"
    else
      flirtingSoundsToUse["6169"] = nil
    end
  else
    flirtingSoundsToUse["6142"] = nil
    flirtingSoundsToUse["6169"] = nil
  end

  if EgoBooster.db.profile.nightElf == true then
    if EgoBooster.db.profile.femaleOn == true then
      flirtingSoundsToUse["6178"] = "nightElf Female"
    else
      flirtingSoundsToUse["6178"] = nil
    end
    if EgoBooster.db.profile.maleOn == true then
      flirtingSoundsToUse["6187"] = "nightElf Male"
    else
      flirtingSoundsToUse["6187"] = nil
    end
  else
    flirtingSoundsToUse["6178"] = nil
    flirtingSoundsToUse["6187"] = nil
  end

  if EgoBooster.db.profile.orc == true then
    if EgoBooster.db.profile.femaleOn == true then
      flirtingSoundsToUse["6358"] = "orc Female"
    else
      flirtingSoundsToUse["6358"] = nil
    end
    if EgoBooster.db.profile.maleOn == true then
      flirtingSoundsToUse["6367"] = "orc Male"
    else
      flirtingSoundsToUse["6367"] = nil
    end
  else
    flirtingSoundsToUse["6358"] = nil
    flirtingSoundsToUse["6367"] = nil
  end

  if EgoBooster.db.profile.pandaren == true then
    if EgoBooster.db.profile.femaleOn == true then
      flirtingSoundsToUse["31728"] = "pandaren Female"
    else
      flirtingSoundsToUse["31728"] = nil
    end
    if EgoBooster.db.profile.maleOn == true then
      flirtingSoundsToUse["31730"] = "pandaren Male"
    else
      flirtingSoundsToUse["31730"] = nil
    end
  else
    flirtingSoundsToUse["31728"] = nil
    flirtingSoundsToUse["31730"] = nil
  end

  if EgoBooster.db.profile.tauren == true then
    if EgoBooster.db.profile.femaleOn == true then
      flirtingSoundsToUse["6376"] = "tauren Female"
    else
      flirtingSoundsToUse["6376"] = nil
    end
    if EgoBooster.db.profile.maleOn == true then
      flirtingSoundsToUse["6385"] = "tauren Male"
    else
      flirtingSoundsToUse["6385"] = nil
    end
  else
    flirtingSoundsToUse["6376"] = nil
    flirtingSoundsToUse["6385"] = nil
  end

  if EgoBooster.db.profile.troll == true then
    if EgoBooster.db.profile.femaleOn == true then
      flirtingSoundsToUse["6394"] = "troll Female"
    else
      flirtingSoundsToUse["6394"] = nil
    end
    if EgoBooster.db.profile.maleOn == true then
      flirtingSoundsToUse["6403"] = "troll Male"
    else
      flirtingSoundsToUse["6403"] = nil
    end
  else
    flirtingSoundsToUse["6394"] = nil
    flirtingSoundsToUse["6403"] = nil
  end

  if EgoBooster.db.profile.undead == true then
    if EgoBooster.db.profile.femaleOn == true then
      flirtingSoundsToUse["6412"] = "undead Female"
    else
      flirtingSoundsToUse["6412"] = nil
    end
    if EgoBooster.db.profile.maleOn == true then
      flirtingSoundsToUse["6421"] = "undead Male"
    else
      flirtingSoundsToUse["6421"] = nil
    end
  else
    flirtingSoundsToUse["6412"] = nil
    flirtingSoundsToUse["6421"] = nil
  end

  if EgoBooster.db.profile.worgen == true then
    if EgoBooster.db.profile.femaleOn == true then
      flirtingSoundsToUse["18759"] = "worgen Female"
    else
      flirtingSoundsToUse["18759"] = nil
    end
    if EgoBooster.db.profile.maleOn == true then
      flirtingSoundsToUse["19013"] = "worgen Male"
    else
      flirtingSoundsToUse["19013"] = nil
    end
  else
    flirtingSoundsToUse["18759"] = nil
    flirtingSoundsToUse["19013"] = nil
  end
  
  if EgoBooster.db.profile.voidelf == true then
    if EgoBooster.db.profile.femaleOn == true then
      flirtingSoundsToUse["91335"] = "voidelf Female"
      flirtingSoundsToUse["91336"] = "voidelf Female"
      flirtingSoundsToUse["91337"] = "voidelf Female"
      flirtingSoundsToUse["91338"] = "voidelf Female"
      flirtingSoundsToUse["91339"] = "voidelf Female"
      flirtingSoundsToUse["91340"] = "voidelf Female"
    else
      flirtingSoundsToUse["91335"] = nil
      flirtingSoundsToUse["91336"] = nil
      flirtingSoundsToUse["91337"] = nil
      flirtingSoundsToUse["91338"] = nil
      flirtingSoundsToUse["91339"] = nil
      flirtingSoundsToUse["91340"] = nil
    end
    if EgoBooster.db.profile.maleOn == true then
      flirtingSoundsToUse["91349"] = "voidelf Male"
      flirtingSoundsToUse["91350"] = "voidelf Male"
      flirtingSoundsToUse["91351"] = "voidelf Male"
      --flirtingSoundsToUse["91352"] = "voidelf Male" missing
      flirtingSoundsToUse["91353"] = "voidelf Male"
      flirtingSoundsToUse["91354"] = "voidelf Male"
      flirtingSoundsToUse["91355"] = "voidelf Male"
    else
      flirtingSoundsToUse["91349"] = nil
      flirtingSoundsToUse["91350"] = nil
      flirtingSoundsToUse["91351"] = nil
      --flirtingSoundsToUse["91352"] = nil missing
      flirtingSoundsToUse["91353"] = nil
      flirtingSoundsToUse["91354"] = nil
      flirtingSoundsToUse["91355"] = nil
    end
  else
	  flirtingSoundsToUse["91335"] = nil
      flirtingSoundsToUse["91336"] = nil
      flirtingSoundsToUse["91337"] = nil
      flirtingSoundsToUse["91338"] = nil
      flirtingSoundsToUse["91339"] = nil
      flirtingSoundsToUse["91340"] = nil
	  flirtingSoundsToUse["91349"] = nil
      flirtingSoundsToUse["91350"] = nil
      flirtingSoundsToUse["91351"] = nil
      --flirtingSoundsToUse["91352"] = nil missing
      flirtingSoundsToUse["91353"] = nil
      flirtingSoundsToUse["91354"] = nil
      flirtingSoundsToUse["91355"] = nil
  end
  
  if EgoBooster.db.profile.lightdrenai == true then
    if EgoBooster.db.profile.femaleOn == true then
      flirtingSoundsToUse["91261"] = "lightdrenai Female"
      flirtingSoundsToUse["91262"] = "lightdrenai Female"
      flirtingSoundsToUse["91263"] = "lightdrenai Female"
      flirtingSoundsToUse["91264"] = "lightdrenai Female"
      flirtingSoundsToUse["91265"] = "lightdrenai Female"
      flirtingSoundsToUse["91266"] = "lightdrenai Female"
      flirtingSoundsToUse["91267"] = "lightdrenai Female"
    else
      flirtingSoundsToUse["91261"] = nil
      flirtingSoundsToUse["91262"] = nil
      flirtingSoundsToUse["91263"] = nil
      flirtingSoundsToUse["91264"] = nil
      flirtingSoundsToUse["91265"] = nil
      flirtingSoundsToUse["91266"] = nil
      flirtingSoundsToUse["91267"] = nil
    end
    if EgoBooster.db.profile.maleOn == true then
      flirtingSoundsToUse["91278"] = "lightdrenai Male"
      --flirtingSoundsToUse["91279"] = "lightdrenai Male" missing
      --flirtingSoundsToUse["91280"] = "lightdrenai Male" missing
      flirtingSoundsToUse["91281"] = "lightdrenai Male" 
      flirtingSoundsToUse["91282"] = "lightdrenai Male"
      flirtingSoundsToUse["91283"] = "lightdrenai Male"
      flirtingSoundsToUse["91284"] = "lightdrenai Male"
    else
      flirtingSoundsToUse["91278"] = nil
      --flirtingSoundsToUse["91279"] = nil missing
      --flirtingSoundsToUse["91280"] = nil missing
      flirtingSoundsToUse["91281"] = nil 
      flirtingSoundsToUse["91282"] = nil
      flirtingSoundsToUse["91283"] = nil
      flirtingSoundsToUse["91284"] = nil
    end
  else
	  flirtingSoundsToUse["91261"] = nil
      flirtingSoundsToUse["91262"] = nil
      flirtingSoundsToUse["91263"] = nil
      flirtingSoundsToUse["91264"] = nil
      flirtingSoundsToUse["91265"] = nil
      flirtingSoundsToUse["91266"] = nil
      flirtingSoundsToUse["91267"] = nil
	  flirtingSoundsToUse["91278"] = nil
      --flirtingSoundsToUse["91279"] = nil missing
      --flirtingSoundsToUse["91280"] = nil missing
      flirtingSoundsToUse["91281"] = nil 
      flirtingSoundsToUse["91282"] = nil
      flirtingSoundsToUse["91283"] = nil
      flirtingSoundsToUse["91284"] = nil
  end
  
  if EgoBooster.db.profile.nightborn == true then
    if EgoBooster.db.profile.femaleOn == true then
      flirtingSoundsToUse["91293"] = "nightborn Female"
      flirtingSoundsToUse["91294"] = "nightborn Female"
      --flirtingSoundsToUse["91295"] = "nightborn Female" missing
      flirtingSoundsToUse["91296"] = "nightborn Female"
      flirtingSoundsToUse["91297"] = "nightborn Female"
      flirtingSoundsToUse["91298"] = "nightborn Female"
      flirtingSoundsToUse["91299"] = "nightborn Female"
    else
      flirtingSoundsToUse["91293"] = nil
      flirtingSoundsToUse["91294"] = nil
      --flirtingSoundsToUse["91295"] = nil missing
      flirtingSoundsToUse["91296"] = nil
      flirtingSoundsToUse["91297"] = nil
      flirtingSoundsToUse["91298"] = nil
      flirtingSoundsToUse["91299"] = nil
    end
    if EgoBooster.db.profile.maleOn == true then
      flirtingSoundsToUse["91308"] = "nightborn Male"
      flirtingSoundsToUse["91309"] = "nightborn Male" 
      flirtingSoundsToUse["91310"] = "nightborn Male" 
      flirtingSoundsToUse["91311"] = "nightborn Male" 
      flirtingSoundsToUse["91312"] = "nightborn Male"
      flirtingSoundsToUse["91313"] = "nightborn Male"
      flirtingSoundsToUse["91314"] = "nightborn Male"
    else
      flirtingSoundsToUse["91308"] = nil
      flirtingSoundsToUse["91309"] = nil 
      flirtingSoundsToUse["91310"] = nil 
      flirtingSoundsToUse["91311"] = nil 
      flirtingSoundsToUse["91312"] = nil
      flirtingSoundsToUse["91313"] = nil
      flirtingSoundsToUse["91314"] = nil
    end
  else
	  flirtingSoundsToUse["91293"] = nil
      flirtingSoundsToUse["91294"] = nil
      --flirtingSoundsToUse["91295"] = nil missing
      flirtingSoundsToUse["91296"] = nil
      flirtingSoundsToUse["91297"] = nil
      flirtingSoundsToUse["91298"] = nil
      flirtingSoundsToUse["91299"] = nil
	  flirtingSoundsToUse["91308"] = nil
      flirtingSoundsToUse["91309"] = nil 
      flirtingSoundsToUse["91310"] = nil 
      flirtingSoundsToUse["91311"] = nil 
      flirtingSoundsToUse["91312"] = nil
      flirtingSoundsToUse["91313"] = nil
      flirtingSoundsToUse["91314"] = nil
  end
  
  if EgoBooster.db.profile.hightaurents == true then
    if EgoBooster.db.profile.femaleOn == true then
      flirtingSoundsToUse["91209"] = "hightaurents Female"
      --flirtingSoundsToUse["91210"] = "hightaurents Female" missing
      flirtingSoundsToUse["91211"] = "hightaurents Female" 
      flirtingSoundsToUse["91212"] = "hightaurents Female"
      flirtingSoundsToUse["91213"] = "hightaurents Female"
      flirtingSoundsToUse["91214"] = "hightaurents Female"
      flirtingSoundsToUse["91215"] = "hightaurents Female"
    else
      flirtingSoundsToUse["91209"] = nil
      --flirtingSoundsToUse["91210"] = nil missing
      flirtingSoundsToUse["91211"] = nil 
      flirtingSoundsToUse["91212"] = nil
      flirtingSoundsToUse["91213"] = nil
      flirtingSoundsToUse["91214"] = nil
      flirtingSoundsToUse["91215"] = nil
    end
    if EgoBooster.db.profile.maleOn == true then
      flirtingSoundsToUse["91226"] = "hightaurents Male"
      flirtingSoundsToUse["91227"] = "hightaurents Male" 
      flirtingSoundsToUse["91228"] = "hightaurents Male" 
      flirtingSoundsToUse["91229"] = "hightaurents Male" 
      flirtingSoundsToUse["91230"] = "hightaurents Male"
      --flirtingSoundsToUse["91231"] = "hightaurents Male" missing
      flirtingSoundsToUse["91232"] = "hightaurents Male"
    else
      flirtingSoundsToUse["91226"] = nil
      flirtingSoundsToUse["91227"] = nil 
      flirtingSoundsToUse["91228"] = nil 
      flirtingSoundsToUse["91229"] = nil 
      flirtingSoundsToUse["91230"] = nil
      --flirtingSoundsToUse["91231"] = nil missing
      flirtingSoundsToUse["91232"] = nil
    end
  else
	  flirtingSoundsToUse["91209"] = nil
      --flirtingSoundsToUse["91210"] = nil missing
      flirtingSoundsToUse["91211"] = nil 
      flirtingSoundsToUse["91212"] = nil
      flirtingSoundsToUse["91213"] = nil
      flirtingSoundsToUse["91214"] = nil
      flirtingSoundsToUse["91215"] = nil
	  flirtingSoundsToUse["91226"] = nil
      flirtingSoundsToUse["91227"] = nil 
      flirtingSoundsToUse["91228"] = nil 
      flirtingSoundsToUse["91229"] = nil 
      flirtingSoundsToUse["91230"] = nil
      --flirtingSoundsToUse["91231"] = nil missing
      flirtingSoundsToUse["91232"] = nil
  end

  if EgoBooster.db.profile.sayWhatAgain == true then
    flirtingSoundsToUse[soundMap["saywhat"]] = "saywaht"
  else
    flirtingSoundsToUse[soundMap["saywhat"]] = nil
  end

  if EgoBooster.db.profile.damnSon == true then
    flirtingSoundsToUse[soundMap["damnson"]] = "damnson"
  else
    flirtingSoundsToUse[soundMap["damnson"]] = nil
  end

  if EgoBooster.db.profile.floatLike == true then
    flirtingSoundsToUse[soundMap["floatlike"]] = "floatlike"
  else
    flirtingSoundsToUse[soundMap["floatlike"]] = nil
  end

  if EgoBooster.db.profile.leeroy == true then
    flirtingSoundsToUse[soundMap["leeroy"]] = "leeroy"
  else
    flirtingSoundsToUse[soundMap["leeroy"]] = nil
  end

  if EgoBooster.db.profile.noonehas == true then
    flirtingSoundsToUse[soundMap["noonehas"]] = "noonehas"
  else
    flirtingSoundsToUse[soundMap["noonehas"]] = nil
  end

  if EgoBooster.db.profile.thuglife == true then
    flirtingSoundsToUse[soundMap["thuglife"]] = "thuglife"
  else
    flirtingSoundsToUse[soundMap["thuglife"]] = nil
  end

  if EgoBooster.db.profile.yahoo == true then
    flirtingSoundsToUse[soundMap["yahoo"]] = "yahoo"
  else
    flirtingSoundsToUse[soundMap["yahoo"]] = nil
  end
  
  if EgoBooster.db.profile.whoami == true then
    flirtingSoundsToUse[soundMap["whoami"]] = "whoami"
  else
    flirtingSoundsToUse[soundMap["whoami"]] = nil
  end

end


